//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@ft[WGtFNg v0.5
//@@@by iuser/5145841j
//
//@@@̃tB^͂ڂl̃fBt[WtB^
//@@@@邢{J{̌ʂ̂ݓ悤ɂ̂łB
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@[U[p[^

//@񓧉߃[hi 0: ͂̂܂܏óA1: 𔒔wiƂďój
#define NON_TRANSPARENT 1

//ڂ̃TvO
#define SAMP_NUM  7

//@gpeNX`i 0: eNX`A1: _eNX`j
#define USE_FLOAT_TEXTURE 0

//@ڂ͈(TvO͌Œ̂߁A傫ƎȂo܂)
//@@ݒ 0.001953125i=2^-9j
float Extent = 0.001953125;

//@ȈՐF␳i , , i,j̏ɎwA1ŕωȂj
//@@ݒ 1.0, 1.0, 1.0, 1.0
float3 ColorFilter
<
   string UIName = "ȈՐF␳";
   string UIWidget = "Spinner";
   bool UIVisible =  true;
   float3 UIMin = float3( 0.0, 0.0, 0.0 );
   float3 UIMax = float3( 2.0, 2.0, 2.0 );
> = float3( 1.0, 1.0, 1.0 );

//@MMDo͂ƍ䗦i0ŕωȂA1ɋ߂ÂقǃGtFNgj
//@@ݒ 0.6666667i= 2/3j
float Strength
<
   string UIName = "䗦";
   string UIWidget = "Spinner";
   bool UIVisible =  true;
   float UIMin = 0.0;
   float UIMax = 1.0;
> = 2.0/3.0;


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@`
#define B_COLOR 0.5

//@_O^[Qbg̃NAl
#if NON_TRANSPARENT
float4 ClearColor = {1.0, 1.0, 1.0, 1.0};
#else
float4 ClearColor = {B_COLOR, B_COLOR, B_COLOR, 0.0};
#endif
float ClearDepth  = 1.0;

//@|XgGtFNg錾
float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;

//@ANZTݒl擾
float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
static float alpha1 = MaterialDiffuse.a;

float scaling0 : CONTROLOBJECT < string name = "(self)"; >;
static float scaling = scaling0 * 0.1;

float3 ObjXYZ0 : CONTROLOBJECT < string name = "(self)"; >;
static float3 ObjXYZ = ObjXYZ0 + 1.0;

//@XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(Extent,Extent)/ViewportSize*ViewportSize.y) * scaling;

//@[xobt@
texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    string Format = "D24S8";
>;

//@IWi̕`挋ʂL^邽߂̃_[^[Qbg
texture2D ScnMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
#if USE_FLOAT_TEXTURE
	string Format = "A16B16G16R16F";
#else
	string Format = "A8R8G8B8";
#endif
>;
sampler2D ScnSamp = sampler_state {
    texture = <ScnMap>;
    MinFilter = NONE;
    MagFilter = NONE;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

//@ȏZX̂ڂʂL^邽߂̃_[^[Qbg
texture2D ScnMap2 : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
#if USE_FLOAT_TEXTURE
	string Format = "A16B16G16R16F";
#else
	string Format = "A8R8G8B8";
#endif
>;
sampler2D ScnSamp2 = sampler_state {
    texture = <ScnMap2>;
    MinFilter = NONE;
    MagFilter = NONE;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// ʒ_VF[_
struct VS_OUTPUT {
    float4 Pos            : POSITION;
    float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + ViewportOffset;
    
    return Out;
}


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Xڂ

float4 PS_passX( float2 Tex: TEXCOORD0 ) : COLOR {   
    float4 sum = 0;
    float e, f, n = 0;
    
    [unroll] //[vWJ
    for(int i = -SAMP_NUM; i <= SAMP_NUM; i++){
		f = float(i);

		e = exp(-pow(f / (SAMP_NUM / 2.0), 2.0) / 2.0); //Kz
        sum += pow(tex2D(ScnSamp, float2(Tex.x + SampStep.x * f, Tex.y)), 2.0) * e; //RGB2
        n += e;
    }
    
    return sum / n;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Yڂ + 

float4 PS_passY(float2 Tex: TEXCOORD0) : COLOR
{   
    float4 Color, sum = 0;
    
    float e, f, n = 0;
    
    [unroll] //[vWJ
    for(int i = -SAMP_NUM; i <= SAMP_NUM; i++){
		f = float(i);

		e = exp(-pow(f / (SAMP_NUM / 2.0), 2.0) / 2.0); //Kz
		sum += tex2D(ScnSamp2, float2(Tex.x, Tex.y + SampStep.y * f)) * e;
		n += e;
    }
    Color = sum / n;

	float4 ColorOrg = tex2D(ScnSamp, Tex);
    float4 ColorSrc = float4(pow(ColorOrg.rgb, 2), ColorOrg.a);

    // Color = Z + {JiPbj@ColorW = ʁ@ColorSrc = ZiPaj@ColorOrg = MMD
    //@XN[
    Color = ColorSrc + Color - ColorSrc * Color;

	//@F␳ʂÂɔႳč
	Color.rgb = lerp(Color.rgb * ObjXYZ * ColorFilter, Color.rgb, Color.rgb);

	//@MMD o͂ƍʂrijŃuh
	Color = max(Color, ColorOrg);

	//@䗦ƃANZT̕sxɃIWiƍ
	Color = lerp(ColorOrg, Color, Strength * alpha1);
#if NON_TRANSPARENT == 0
//	Color.a = max(ColorOrg.a, Color.a);	//@ɂ{JV͂ݏoꍇ
	Color.a = ColorOrg.a;				//@ɂ̓{JV͂ݏoȂꍇ
#endif
	return Color;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

technique Diffusion <
    string Script = 
        
        "RenderColorTarget0=ScnMap;"
        "RenderDepthStencilTarget=DepthBuffer;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "ScriptExternal=Color;"
        
        "RenderColorTarget0=ScnMap2;"
        "RenderDepthStencilTarget=DepthBuffer;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "Pass=Gaussian_X;"
        
        "RenderColorTarget0=;"
        "RenderDepthStencilTarget=;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "Pass=Gaussian_Y;"
    ;
    
> {
    pass Gaussian_X < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_passDraw();
        PixelShader  = compile ps_2_0 PS_passX();
    }
    pass Gaussian_Y < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_passDraw();
        PixelShader  = compile ps_2_0 PS_passY();
    }
}
////////////////////////////////////////////////////////////////////////////////////////////////
